Index: branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/ConstructionBudget/ProcessControl.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/ConstructionBudget/ProcessControl.cs	(revision 50)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/ConstructionBudget/ProcessControl.cs	(revision 51)
@@ -26,10 +26,12 @@
 {
     partial class FrmConstructionBudget
     {
+        #region 自プロセスの番号
         /// <summary>
         /// 自プロセスの番号を持つ
         /// </summary>
         private static int s_CurrentProcessNo = (int)ClsExcute.ProcessExecuteNo.ConstructionBudget;
+ 		#endregion
 
         #region プロセスコンテキストメニュー変数
         /// <summary>
@@ -38,13 +40,6 @@
         private ContextMenuStrip m_ProcessContextMenuStrip;
         #endregion
 
-        #region 他プロセスフォーム配列変数
-        /// <summary>
-        /// 他プロセスフォーム配列
-        /// </summary>
-        //private Form[] ClsExcute.SubFormHandleList = null;
-        #endregion
-
         #region 別プロセス移動メニュー作成
         /// <summary>
         /// 別プロセス移動メニュー作成
@@ -121,6 +116,7 @@
                             handle = ProcessExecute_ConstructionBudget;
                             break;
                         case (int)ClsExcute.ProcessExecuteNo.ConstructionCopyList:      //  8:工事案件コピー機能
+                            if (m_EditLock) continue;
                             handle = ProcessExecute_ConstructionCopyList;
                             break;
                         case (int)ClsExcute.ProcessExecuteNo.PurchaseOrderEntry:        //  9:注文書入力
@@ -209,6 +205,7 @@
 
                     // 画面クローズ
                     Handle.SubFormHandle.Close();
+                    if (Handle.SubFormHandle != null) Handle.SubFormHandle.Dispose();
                     ClsExcute.SubFormHandleList[i].SubFormHandle = null;
                 }
             }
@@ -242,7 +239,7 @@
         }
         #endregion
 
-        #region ---------- 他プロセス起動ハンドラ群　START
+        #region    // ---------- 他プロセス起動ハンドラ群　START
         #region 一気にメニューへ戻る
         /// <summary>
         /// 一気にメニューへ戻る
@@ -286,6 +283,7 @@
         /// <param name="e"></param>
         private void ProcessExecute_ConstructionBaseInfo(object sender, EventArgs e)
         {
+            FrmTyingConstrDiag frmTying = new FrmTyingConstrDiag();
             try
             {
                 int ProcessNo = (int)ClsExcute.ProcessExecuteNo.ConstructionBaseInfo;
@@ -303,11 +301,25 @@
                     if (!DataEntryProcess()) return;
                 }
 
+                // 増減工事はサブフォームを表示する
+                int SelConstrCode = m_ConstructionCode;
+                if (m_ConstructionBaseInfo.TyingFlg != (int)CommonDefine.BaseInfoTyingFlg.Standard ||
+                    m_ConstructionBaseInfo.JoinFlg != (int)CommonDefine.BaseInfoJoinFlg.Standard)
+                {
+                    frmTying.ParentAdd = true;
+                    frmTying.OperationProcess = (int)ClsExcute.ProcessExecuteNo.ConstructionBaseInfo;
+                    frmTying.ConstructionCode = m_ConstructionCode;
+                    frmTying.ShowDialog();
+                    if (frmTying.EndButton == DialogResult.No) return;
+                    SelConstrCode = frmTying.ConstructionCode;
+                }
+
                 // 工事情報入力起動
                 frm = new FrmConstructionBaseInfo();
                 ClsExcute.SubFormHandleList[ProcessNo].ProcessNo = s_CurrentProcessNo;
                 ClsExcute.SubFormHandleList[ProcessNo].SubFormHandle = (Form)frm;
-                frm.ConstructionCode = m_ConstructionCode;
+                frm.ConstructionCode = SelConstrCode;
+                frm.EditLock = m_EditLock;
                 frm.SubForm = true;
                 frm.ShowInTaskbar = true;
 
@@ -319,6 +331,10 @@
             {
                 logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
             }
+            finally
+            {
+                frmTying.Dispose(); frmTying = null;
+            }
         }
         #endregion
 
@@ -330,6 +346,7 @@
         /// <param name="e"></param>
         private void ProcessExecute_EstimateInput(object sender, EventArgs e)
         {
+            FrmTyingConstrDiag frmTying = new FrmTyingConstrDiag();
             try
             {
                 int ProcessNo = (int)ClsExcute.ProcessExecuteNo.EstimateInput;
@@ -347,11 +364,24 @@
                     if (!DataEntryProcess()) return;
                 }
 
+                // 増減工事はサブフォームを表示する
+                int SelConstrCode = m_ConstructionCode;
+                if (m_ConstructionBaseInfo.TyingFlg != (int)CommonDefine.BaseInfoTyingFlg.Standard ||
+                    m_ConstructionBaseInfo.JoinFlg != (int)CommonDefine.BaseInfoJoinFlg.Standard)
+                {
+                    frmTying.OperationProcess = (int)ClsExcute.ProcessExecuteNo.EstimateInput;
+                    frmTying.ConstructionCode = m_ConstructionCode;
+                    frmTying.ShowDialog();
+                    if (frmTying.EndButton == DialogResult.No) return;
+                    SelConstrCode = frmTying.ConstructionCode;
+                }
+
                 // 積算見積書入力起動
                 frm = new FrmEstimateInput();
                 ClsExcute.SubFormHandleList[ProcessNo].ProcessNo = s_CurrentProcessNo;
                 ClsExcute.SubFormHandleList[ProcessNo].SubFormHandle = (Form)frm;
-                frm.ConstructionCode = m_ConstructionCode;
+                frm.ConstructionCode = SelConstrCode;
+                frm.EditLock = m_EditLock;
                 frm.SubForm = true;
                 frm.ShowInTaskbar = true;
 
@@ -363,6 +393,10 @@
             {
                 logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
             }
+            finally
+            {
+                frmTying.Dispose(); frmTying = null;
+            }
         }
         #endregion
 
@@ -374,6 +408,7 @@
         /// <param name="e"></param>
         private void ProcessExecute_EstimatePrint(object sender, EventArgs e)
         {
+            FrmTyingConstrDiag frmTying = new FrmTyingConstrDiag();
             try
             {
                 int ProcessNo = (int)ClsExcute.ProcessExecuteNo.EstimatePrint;
@@ -391,11 +426,24 @@
                     if (!DataEntryProcess()) return;
                 }
 
+                // 増減工事はサブフォームを表示する
+                int SelConstrCode = m_ConstructionCode;
+                if (m_ConstructionBaseInfo.TyingFlg != (int)CommonDefine.BaseInfoTyingFlg.Standard ||
+                    m_ConstructionBaseInfo.JoinFlg != (int)CommonDefine.BaseInfoJoinFlg.Standard)
+                {
+                    frmTying.OperationProcess = (int)ClsExcute.ProcessExecuteNo.EstimatePrint;
+                    frmTying.ConstructionCode = m_ConstructionCode;
+                    frmTying.ShowDialog();
+                    if (frmTying.EndButton == DialogResult.No) return;
+                    SelConstrCode = frmTying.ConstructionCode;
+                }
+
                 // 積算見積書印刷起動
                 frm = new FrmEstimatePrint();
                 ClsExcute.SubFormHandleList[ProcessNo].ProcessNo = s_CurrentProcessNo;
                 ClsExcute.SubFormHandleList[ProcessNo].SubFormHandle = (Form)frm;
-                frm.ConstructionCode = m_ConstructionCode;
+                frm.ConstructionCode = SelConstrCode;
+                frm.EditLock = m_EditLock;
                 frm.SubForm = true;
                 frm.ShowInTaskbar = true;
 
@@ -407,6 +455,10 @@
             {
                 logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
             }
+            finally
+            {
+                frmTying.Dispose(); frmTying = null;
+            }
         }
         #endregion
 
@@ -418,6 +470,7 @@
         /// <param name="e"></param>
         private void ProcessExecute_EstimateBudget(object sender, EventArgs e)
         {
+            FrmTyingConstrDiag frmTying = new FrmTyingConstrDiag();
             try
             {
                 int ProcessNo = (int)ClsExcute.ProcessExecuteNo.EstimateBudget;
@@ -435,11 +488,24 @@
                     if (!DataEntryProcess()) return;
                 }
 
+                // 増減工事はサブフォームを表示する
+                int SelConstrCode = m_ConstructionCode;
+                if (m_ConstructionBaseInfo.TyingFlg != (int)CommonDefine.BaseInfoTyingFlg.Standard ||
+                    m_ConstructionBaseInfo.JoinFlg != (int)CommonDefine.BaseInfoJoinFlg.Standard)
+                {
+                    frmTying.OperationProcess = (int)ClsExcute.ProcessExecuteNo.EstimateBudget;
+                    frmTying.ConstructionCode = m_ConstructionCode;
+                    frmTying.ShowDialog();
+                    if (frmTying.EndButton == DialogResult.No) return;
+                    SelConstrCode = frmTying.ConstructionCode;
+                }
+
                 // 積算予算書入力起動
                 frm = new FrmEstimateBudget();
                 ClsExcute.SubFormHandleList[ProcessNo].ProcessNo = s_CurrentProcessNo;
                 ClsExcute.SubFormHandleList[ProcessNo].SubFormHandle = (Form)frm;
-                frm.ConstructionCode = m_ConstructionCode;
+                frm.ConstructionCode = SelConstrCode;
+                frm.EditLock = m_EditLock;
                 frm.SubForm = true;
                 frm.ShowInTaskbar = true;
 
@@ -451,6 +517,10 @@
             {
                 logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
             }
+            finally
+            {
+                frmTying.Dispose(); frmTying = null;
+            }
         }
         #endregion
 
@@ -462,6 +532,7 @@
         /// <param name="e"></param>
         private void ProcessExecute_ConstructionBudget(object sender, EventArgs e)
         {
+            FrmTyingConstrDiag frmTying = new FrmTyingConstrDiag();
             try
             {
                 int ProcessNo = (int)ClsExcute.ProcessExecuteNo.ConstructionBudget;
@@ -479,11 +550,24 @@
                     if (!DataEntryProcess()) return;
                 }
 
+                // 増減工事はサブフォームを表示する
+                int SelConstrCode = m_ConstructionCode;
+                if (m_ConstructionBaseInfo.TyingFlg != (int)CommonDefine.BaseInfoTyingFlg.Standard ||
+                    m_ConstructionBaseInfo.JoinFlg != (int)CommonDefine.BaseInfoJoinFlg.Standard)
+                {
+                    frmTying.OperationProcess = (int)ClsExcute.ProcessExecuteNo.ConstructionBudget;
+                    frmTying.ConstructionCode = m_ConstructionCode;
+                    frmTying.ShowDialog();
+                    if (frmTying.EndButton == DialogResult.No) return;
+                    SelConstrCode = frmTying.ConstructionCode;
+                }
+
                 // 工事予算書入力起動
                 frm = new FrmConstructionBudget();
                 ClsExcute.SubFormHandleList[ProcessNo].ProcessNo = s_CurrentProcessNo;
                 ClsExcute.SubFormHandleList[ProcessNo].SubFormHandle = (Form)frm;
-                frm.ConstructionCode = m_ConstructionCode;
+                frm.ConstructionCode = SelConstrCode;
+                frm.EditLock = m_EditLock;
                 frm.SubForm = true;
                 frm.ShowInTaskbar = true;
 
@@ -495,6 +579,10 @@
             {
                 logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
             }
+            finally
+            {
+                frmTying.Dispose(); frmTying = null;
+            }
         }
         #endregion
 
@@ -506,6 +594,7 @@
         /// <param name="e"></param>
         private void ProcessExecute_ConstructionCopyList(object sender, EventArgs e)
         {
+            FrmTyingConstrDiag frmTying = new FrmTyingConstrDiag();
             try
             {
                 int ProcessNo = (int)ClsExcute.ProcessExecuteNo.ConstructionCopyList;
@@ -523,11 +612,23 @@
                     if (!DataEntryProcess()) return;
                 }
 
+                // 増減工事はサブフォームを表示する
+                int SelConstrCode = m_ConstructionCode;
+                if (m_ConstructionBaseInfo.TyingFlg != (int)CommonDefine.BaseInfoTyingFlg.Standard ||
+                    m_ConstructionBaseInfo.JoinFlg != (int)CommonDefine.BaseInfoJoinFlg.Standard)
+                {
+                    frmTying.OperationProcess = (int)ClsExcute.ProcessExecuteNo.ConstructionCopyList;
+                    frmTying.ConstructionCode = m_ConstructionCode;
+                    frmTying.ShowDialog();
+                    if (frmTying.EndButton == DialogResult.No) return;
+                    SelConstrCode = frmTying.ConstructionCode;
+                }
+
                 // 工事案件コピー起動
                 frm = new FrmNewOrContinueCopy();
                 ClsExcute.SubFormHandleList[ProcessNo].ProcessNo = s_CurrentProcessNo;
                 ClsExcute.SubFormHandleList[ProcessNo].SubFormHandle = (Form)frm;
-                frm.ConstructionCode = m_ConstructionCode;
+                frm.ConstructionCode = SelConstrCode;
                 frm.ShowInTaskbar = true;
 
                 // クロースドハンドラをこちらで定義する
@@ -538,6 +639,10 @@
             {
                 logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
             }
+            finally
+            {
+                frmTying.Dispose(); frmTying = null;
+            }
         }
         #endregion
 
@@ -549,6 +654,7 @@
         /// <param name="e"></param>
         private void ProcessExecute_PurchaseOrderEntry(object sender, EventArgs e)
         {
+            FrmTyingConstrDiag frmTying = new FrmTyingConstrDiag();
             try
             {
                 int ProcessNo = (int)ClsExcute.ProcessExecuteNo.PurchaseOrderEntry;
@@ -566,11 +672,25 @@
                     if (!DataEntryProcess()) return;
                 }
 
+                // 増減工事はサブフォームを表示する
+                int SelConstrCode = m_ConstructionCode;
+                if (m_ConstructionBaseInfo.TyingFlg != (int)CommonDefine.BaseInfoTyingFlg.Standard ||
+                    m_ConstructionBaseInfo.JoinFlg != (int)CommonDefine.BaseInfoJoinFlg.Standard)
+                {
+                    frmTying.ParentAdd = true;
+                    frmTying.OperationProcess = (int)ClsExcute.ProcessExecuteNo.PurchaseOrderEntry;
+                    frmTying.ConstructionCode = m_ConstructionCode;
+                    frmTying.ShowDialog();
+                    if (frmTying.EndButton == DialogResult.No) return;
+                    SelConstrCode = frmTying.ConstructionCode;
+                }
+
                 // 注文書入力起動
                 frm = new FrmPurchaseOrderEntry();
                 ClsExcute.SubFormHandleList[ProcessNo].ProcessNo = s_CurrentProcessNo;
                 ClsExcute.SubFormHandleList[ProcessNo].SubFormHandle = (Form)frm;
-                frm.ConstructionCode = m_ConstructionCode;
+                frm.ConstructionCode = SelConstrCode;
+                frm.EditLock = m_EditLock;
                 frm.SubForm = true;
                 frm.ShowInTaskbar = true;
 
@@ -582,6 +702,10 @@
             {
                 logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
             }
+            finally
+            {
+                frmTying.Dispose(); frmTying = null;
+            }
         }
         #endregion
 
@@ -593,6 +717,7 @@
         /// <param name="e"></param>
         private void ProcessExecute_PurchaseOrderPrint(object sender, EventArgs e)
         {
+            FrmTyingConstrDiag frmTying = new FrmTyingConstrDiag();
             try
             {
                 int ProcessNo = (int)ClsExcute.ProcessExecuteNo.PurchaseOrderPrint;
@@ -610,11 +735,25 @@
                     if (!DataEntryProcess()) return;
                 }
 
+                // 増減工事はサブフォームを表示する
+                int SelConstrCode = m_ConstructionCode;
+                if (m_ConstructionBaseInfo.TyingFlg != (int)CommonDefine.BaseInfoTyingFlg.Standard ||
+                    m_ConstructionBaseInfo.JoinFlg != (int)CommonDefine.BaseInfoJoinFlg.Standard)
+                {
+                    frmTying.ParentAdd = true;
+                    frmTying.OperationProcess = (int)ClsExcute.ProcessExecuteNo.PurchaseOrderPrint;
+                    frmTying.ConstructionCode = m_ConstructionCode;
+                    frmTying.ShowDialog();
+                    if (frmTying.EndButton == DialogResult.No) return;
+                    SelConstrCode = frmTying.ConstructionCode;
+                }
+
                 // 注文書印刷起動
                 frm = new FrmPurchaseOrderPrint();
                 ClsExcute.SubFormHandleList[ProcessNo].ProcessNo = s_CurrentProcessNo;
                 ClsExcute.SubFormHandleList[ProcessNo].SubFormHandle = (Form)frm;
-                frm.ConstructionCode = m_ConstructionCode;
+                frm.ConstructionCode = SelConstrCode;
+                frm.EditLock = m_EditLock;
                 frm.SubForm = true;
                 frm.ShowInTaskbar = true;
 
@@ -626,6 +765,10 @@
             {
                 logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
             }
+            finally
+            {
+                frmTying.Dispose(); frmTying = null;
+            }
         }
         #endregion
 
@@ -659,6 +802,7 @@
                 ClsExcute.SubFormHandleList[ProcessNo].ProcessNo = s_CurrentProcessNo;
                 ClsExcute.SubFormHandleList[ProcessNo].SubFormHandle = (Form)frm;
                 frm.ConstructionCode = ClsProcessExist.GetParentConstrCode(m_ConstructionCode);
+                frm.EditLock = m_EditLock;
                 frm.SubForm = true;
                 frm.ShowInTaskbar = true;
 
@@ -703,6 +847,8 @@
                 ClsExcute.SubFormHandleList[ProcessNo].ProcessNo = s_CurrentProcessNo;
                 ClsExcute.SubFormHandleList[ProcessNo].SubFormHandle = (Form)frm;
                 frm.ConstructionCode = m_ConstructionCode;
+                frm.PersonCode = CommonMotions.LoginUserData.PersonCode;
+                frm.EditLock = m_EditLock;
                 frm.SubForm = true;
                 frm.ShowInTaskbar = true;
 
@@ -719,7 +865,7 @@
 
         #endregion // ---------- 他プロセス起動ハンドラ群　END
 
-        #region ---------- 他プロセス終了ハンドラ群　START
+        #region    // ---------- 他プロセス終了ハンドラ群　START
         #region 工事情報入力のクローズを取得する
         /// <summary>
         /// 工事情報入力のクローズを取得する
@@ -963,11 +1109,12 @@
                 // コピー作成データフラグセット
                 ClsExcute.ProcControlPara[NowPoint].BoolExecParameter.Add(true);
 
-                this.Activate();
+                //this.Activate();
 
                 // 終了処理フラグOff
                 m_CloseingProcessOn = false;
 
+                this.Close();
             }
             catch (Exception ex)
             {
@@ -1136,6 +1283,5 @@
         #endregion
 
         #endregion // ---------- 他プロセス終了ハンドラ群　END
-
     }
 }
